package com.member.db;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.sql.DataSource;

import com.action.JdbcUtil;

public class MemberDAO {

    DataSource ds;
    Connection con = null;
    PreparedStatement pstmt = null;
    ResultSet rs = null;

    public MemberDAO() {

        try{
           
            Context initCtx = new InitialContext();
            Context envCtx = (Context)initCtx.lookup("java:comp/env");
            ds = (DataSource)envCtx.lookup("jdbc/OracleDB");
        }
       
        catch(Exception ex) {

            ex.printStackTrace();
        }
    }

    // ȸ ó  ޼ҵ̴.
    public boolean insertMember(MemberBean mb) throws SQLException {
    	
        String sql = null;
       
        // ȸ  Է  MEMBER ̺ Ѵ.
        try {

            con = ds.getConnection();

            sql = "insert into MEMBER_INFO values(?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";

            pstmt=con.prepareStatement(sql);
            pstmt.setString(1, mb.getMemberUserId());
            pstmt.setString(2, mb.getMemberPassword());
            pstmt.setString(3, mb.getMemberName());
            pstmt.setString(4, mb.getMemberEmail());
            pstmt.setString(5, mb.getMemberEmailGet());
            pstmt.setString(6, mb.getMemberMobile());
            pstmt.setString(7, mb.getMemberPhone());
            pstmt.setString(8, mb.getMemberZipCode());
            pstmt.setString(9, mb.getMemberAddr01());
            pstmt.setString(10, mb.getMemberAddr02());
            pstmt.setInt(11, mb.getMemberAdmin());
            pstmt.setTimestamp(12, mb.getMemberJoinDate());
            pstmt.executeUpdate();

            return true;
        }
       
        catch(Exception e) {

            e.printStackTrace();
        }
       
        finally {
           
			JdbcUtil.close(rs);
			JdbcUtil.close(pstmt);
			JdbcUtil.close(con);
        }
       
        return false;
    }
   
    // ȸ α ó  ޼ҵ̴.
    public int userCheck(String id, String pw) throws SQLException {

        String sql = null;
        int x = -1;
        
        try {
           
            con = ds.getConnection();
           
            // MEMBER ̺κ ȸ йȣ ´.
            sql = "select MEMBER_PASSWORD from MEMBER_INFO where MEMBER_USERID = ?";
           
            pstmt = con.prepareStatement(sql);
            pstmt.setString(1, id);
            rs = pstmt.executeQuery();

            if(rs.next()) {

                String memberpw = rs.getString("MEMBER_PASSWORD");
               
                // ȸ Է йȣ ȸ ̵ йȣ ġϸ 1 ȯѴ.
                if(memberpw.equals(pw)) {

                    x = 1;
                }
               
                // йȣ ġ   0 ȯѴ.
                else {

                    x = 0;
                }
            }
           
            // ̵    -1 ȯѴ.
            else {

                x = -1;
            }

            return x;
        }
       
        catch(Exception e) {

            e.printStackTrace();
        }
       
        finally {

			JdbcUtil.close(rs);
			JdbcUtil.close(pstmt);
			JdbcUtil.close(con);
        }

        return -1;
    }

    // ̵ ϴ Ȯϴ ޼ҵ̴. ȸԽ ߺ Ȯ  ȴ.
    public int confirmId(String id) throws SQLException {

        String sql = null;
        int x = -1;
       
        // ̵ ϴ Ư ̵ MEMBER ̺κ ´.
        try {

            con = ds.getConnection();
           
            sql = "select MEMBER_USERID from MEMBER_INFO where MEMBER_USERID = ?";

            pstmt = con.prepareStatement(sql);
            pstmt.setString(1, id);
            rs = pstmt.executeQuery();
           
            // ̵ ϸ 1 ȯѴ.
            if(rs.next()) {

                x = 1;
            }
           
            // ̵  ʴ´ٸ -1 ȯѴ.
            else {

                x = -1;
            }

            return x;
        }
       
        catch(Exception e) {

            e.printStackTrace();
        }
       
        finally {

			JdbcUtil.close(rs);
			JdbcUtil.close(pstmt);
			JdbcUtil.close(con);
        }

        return -1;
    }
   
    // ȸ  MemberBean ü Ÿ ȯϴ ޼ҵ̴.
    public MemberBean getMember(String id) throws SQLException {

        MemberBean member = null;
        String sql = null;

        try {

            con = ds.getConnection();
           
            sql = "select * from MEMBER_INFO where MEMBER_USERID = ?";
           
            pstmt = con.prepareStatement(sql);
            pstmt.setString(1, id);
            rs = pstmt.executeQuery();

            if(rs.next()) {

                member=new MemberBean();
                member.setMemberUserId(rs.getString("MEMBER_USERID"));
                member.setMemberName(rs.getString("MEMBER_NAME"));
                member.setMemberEmail(rs.getString("MEMBER_EMAIL"));
                member.setMemberEmailGet(rs.getString("MEMBER_EMAIL_GET"));
                member.setMemberMobile(rs.getString("MEMBER_MOBILE"));
                member.setMemberPhone(rs.getString("MEMBER_PHONE"));
                member.setMemberZipCode(rs.getString("MEMBER_ZIPCODE"));
                member.setMemberAddr01(rs.getString("MEMBER_ADDR01"));
                member.setMemberAddr02(rs.getString("MEMBER_ADDR02"));
               
                // member ü ȯѴ.
                return member;
            }
        }
       
        catch(Exception e) {

            e.printStackTrace();
        }
       
        finally {

			JdbcUtil.close(rs);
			JdbcUtil.close(pstmt);
			JdbcUtil.close(con);
        }
       
        return null;
    }
   
    // ȸ  ϴ ޼ҵ̴.
    public void updateMember(MemberBean mb) throws SQLException {

        String sql=null;

        // ȸ  ȸ   Է¹  Ѵ.
        try {

            con = ds.getConnection();
           
            sql = "update MEMBER_INFO set MEMBER_PASSWORD = ?, MEMBER_NAME = ?, "
                + "MEMBER_EMAIL = ?, MEMBER_EMAIL_GET = ?, MEMBER_MOBILE = ?, "
                + "MEMBER_PHONE = ?, MEMBER_ZIPCODE = ?, MEMBER_ADDR01 = ?, "
                + "MEMBER_ADDR02 = ? where MEMBER_USERID = ?";
           
            pstmt=con.prepareStatement(sql);
            pstmt.setString(1, mb.getMemberPassword());
            pstmt.setString(2, mb.getMemberName());
            pstmt.setString(3, mb.getMemberEmail());
            pstmt.setString(4, mb.getMemberEmailGet());
            pstmt.setString(5, mb.getMemberMobile());
            pstmt.setString(6, mb.getMemberPhone());
            pstmt.setString(7, mb.getMemberZipCode());
            pstmt.setString(8, mb.getMemberAddr01());
            pstmt.setString(9, mb.getMemberAddr02());
            pstmt.setString(10, mb.getMemberUserId());           
            pstmt.executeUpdate();
        }
       
        catch(Exception e) {

            e.printStackTrace();
        }
       
        finally {

			JdbcUtil.close(rs);
			JdbcUtil.close(pstmt);
			JdbcUtil.close(con);
        }
    }

    // ȸ Ż óϴ ޼ҵ̴.
    public int deleteMember(String id, String pw) throws SQLException {

        String sql = null;
        int x = -1;
       
        // ŻϷ ȸ йȣ ´.
        try {

            con = ds.getConnection();
           
            sql = "select MEMBER_PASSWORD from MEMBER_INFO where MEMBER_USERID = ?";
           
            pstmt = con.prepareStatement(sql);
            pstmt.setString(1, id);
            rs = pstmt.executeQuery();
           
            if(rs.next()) {

                String memberpw = rs.getString("MEMBER_PASSWORD");
               
                // ȸ Է йȣ ȸ ̵ йȣ ġϸ ȸ  óϰ 1 ȯѴ.
                if(memberpw.equals(pw)) {

                    sql = "delete from MEMBER where MEMBER_USERID = ?";

                    pstmt = con.prepareStatement(sql);
                    pstmt.setString(1, id);
                    pstmt.executeUpdate();
                    x = 1;
                }
               
                // ȸ йȣ ġ   0 ȯѴ.
                else {

                    x = 0;
                }

                return x;
            }
        }
       
        catch(Exception e) {

            e.printStackTrace();
        }
       
        finally {

			JdbcUtil.close(rs);
			JdbcUtil.close(pstmt);
			JdbcUtil.close(con);
        }

        return -1;
    }   

    //  ̵ Ȯϴ ޼ҵ̴.
    public boolean isAdmin(String id) {
       
        // μ Ѿ ȸ ̵ شϴ MEMBER_ADMIN ʵ  ´.
        // MEMBER_ADMIN  θ   ִ.
        String sql = "select MEMBER_ADMIN from MEMBER_INFO where MEMBER_USERID = ?";
        int member_admin = 0;

        try {

            con = ds.getConnection();
            pstmt = con.prepareStatement(sql);
            pstmt.setString(1, id);
            rs = pstmt.executeQuery();
            rs.next();

            member_admin = rs.getInt("MEMBER_ADMIN");

            // ڸ true ȯѴ.
            if(member_admin == 1) {

                return true;
            }
        }
       
        catch (SQLException e) {

            e.printStackTrace();
        }

        finally {

			JdbcUtil.close(rs);
			JdbcUtil.close(pstmt);
			JdbcUtil.close(con);
        }

        return false;
    }
   
    // '(DONG)' ̸ ȣ ˻ϴ ޼ҵ̴.
    public List searchZipcode(String searchdong) {
       
        System.out.println(searchdong);
       
        String sql = "select * from ZIPCODE where DONG like ?";

        List zipcodeList=new ArrayList();

        try {

            con = ds.getConnection();
            pstmt = con.prepareStatement(sql);
           
            // '' ̸ Ե ȣ ˻ϱ Ͽ,  ڿ % δ.
            pstmt.setString(1, "%"+searchdong+"%");
            rs = pstmt.executeQuery();

            // ˻     ȣ ּҷ Ͽ zipcodeList ü ´.
            while(rs.next()){

                String sido = rs.getString("sido");
                String gugun = rs.getString("gugun");
                String dong = rs.getString("dong");
                String ri = rs.getString("ri");
                String bunji=rs.getString("bunji");
               
                if(ri == null) {
                   
                    ri = "";
                }
               
                if(bunji == null) {
                   
                    bunji = "";
                }

                String zipcode=rs.getString("zipcode");
                String addr = sido + " " + gugun + " " + dong + " " + ri + " " + bunji;
               
                // ˻  ִ zipcodeList ü ȯѴ.
                zipcodeList.add(zipcode + ", " + addr);
            }

            return zipcodeList;
        }
       
        catch (SQLException e) {

            e.printStackTrace();
        }

        finally {

			JdbcUtil.close(rs);
			JdbcUtil.close(pstmt);
			JdbcUtil.close(con);
        }
       
        return null;
    }
}